<?php
/**
 * Module Helper File
 *
 * @package     Cache Cleaner
 * @version     1.6.0
 *
 * @author      Peter van Westen <peter@nonumber.nl>
 * @link        http://www.nonumber.nl
 * @copyright   Copyright © 2010 NoNumber! All Rights Reserved
 * @license     http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class modCacheCleaner
{
	function render( $params )
	{
		JHTML::_( 'behavior.mootools' );

		require_once JPATH_PLUGINS.DS.'system'.DS.'nonumberelements'.DS.'helpers'.DS.'functions.php';
		$this->functions =& NNFunctions::getFunctions();
		$mt_version = $this->functions->getJSVersion();

		$document =& JFactory::getDocument();
		$script = "
			var cachecleaner_root = '".JURI::base( true )."';
			var cachecleaner_msg = '".str_replace( "'", "\'", JText::_( 'CC_CLEANING_CACHE' ) )."';
			var cachecleaner_msg_inactive = '".str_replace( "'", "\'", JText::_( 'CC_SYSTEM_PLUGIN_NOT_ENABLED' ) )."';
			var cachecleaner_msg_success = '".str_replace( "'", "\'", JText::_( 'CC_CACHE_CLEANED' ) )."';
			var cachecleaner_msg_failure = '".str_replace( "'", "\'", JText::_( 'CC_CACHE_COULD_NOT_BE_CLEANED' ) )."';";
		$document->addScriptDeclaration( $script );
		$document->addScript( JURI::base( true ).'/modules/mod_cachecleaner/cachecleaner/js/script'.$mt_version.'.js' );
		$document->addStyleSheet( JURI::base( true ).'/modules/mod_cachecleaner/cachecleaner/css/style.css' );

		$text = JText::_( $params->get( 'icon_text', 'CC_CLEAN_CACHE' ) );
		$title = $text;
		$class = '';
		if ( $params->get( 'display_link', 'both' ) == 'text' ) {
			$class = 'no_icon';
		} else if ( $params->get( 'display_link', 'both' ) == 'icon' ) {
			$text = '&nbsp;';
			$class = 'no_text';
		}
		if ( $params->get( 'display_tooltip', 1 ) ) {
			JHTML::_( 'behavior.tooltip' );
			$class .= ' hasTip';
			$title = JText::_( 'CACHE_CLEANER' ).'::'.JText::_( 'CC_CLEAN_YOUR_CACHE' );
		}

		echo '<a href="javascript://" onclick="cachecleaner_load();return false;" onfocus="this.blur();" class="'.trim( $class ).'" id="cachecleaner" title="'.$title.'"><span>'.$text.'</span></a>';
	}
}